<script setup lang="ts">
import { ref, onMounted } from 'vue'
import axios from 'axios'
import { Bar } from 'vue-chartjs'
import {
  Chart as ChartJS,
  Title,
  Tooltip,
  Legend,
  BarElement,
  CategoryScale,
  LinearScale
} from 'chart.js'

onMounted(async () => {
  await getReportDaily()
  await getReportMount()
  await getReportYear()
})

async function getReportDaily() {
  const res = await axios.get('http://localhost:3000/report/reportDaily')
  const labels = res.data.map((it: any) => it.formatted_time) // แก้ไขตรงนี้เป็น Month แทน formatted_time
  const data = res.data.map((it: any) => it.EXPENSES)

  chartData.value = {
    labels: labels,
    datasets: [{ label: 'Total By Daily', backgroundColor: '#f87979', data: data }]
  }
}
async function getReportMount() {
  const res = await axios.get('http://localhost:3000/report/reportMount')
  const labels = res.data.map((it: any) => it.Month) // แก้ไขตรงนี้เป็น Month แทน formatted_time
  const data = res.data.map((it: any) => it.TotalPrice) // แก้ไขตรงนี้เป็น TotalPrice แทน EXPENSES

  chartData.value = {
    labels: labels,
    datasets: [{ label: 'Total By Mount', backgroundColor: '#ce93d8', data: data }]
  }
}
async function getReportYear() {
  const res = await axios.get('http://localhost:3000/report/reportYear')
  const labels = res.data.map((it: any) => it.Year) // แก้ไขตรงนี้เป็น Month แทน formatted_time
  const data = res.data.map((it: any) => it.TotalPrice) // แก้ไขตรงนี้เป็น TotalPrice แทน EXPENSES

  chartData.value = {
    labels: labels,
    datasets: [{ label: 'Total By Year', backgroundColor: '#80deea', data: data }]
  }
}

ChartJS.register(Title, Tooltip, Legend, BarElement, CategoryScale, LinearScale)

const chartData = ref({
  labels: [],
  datasets: [{ label: 'Bill', backgroundColor: '#f87979', data: [] }]
})
const chartOptions = ref({
  responsive: true,
  maintainAspectRatio: false,
  scales: {
    y: {
      title: {
        display: true,
        text: 'Expenses'
      }
    }
  }
})

const showDialog = ref(false)

const changeChartData = (type: string) => {
  switch (type) {
    case 'date':
      getReportDaily()
      break
    case 'month':
      getReportMount()
      break
    case 'year':
      getReportYear()
      break
    default:
      break
  }
}
</script>

<template>
  <div>
    <!-- Button to open the dialog -->
    <v-btn @click="showDialog = true">Show Chart</v-btn>

    <!-- Dialog containing the chart inside v-card -->
    <v-dialog v-model="showDialog" max-width="800">
      <v-card class="chart-card">
        <v-card-title>Chart Title</v-card-title>
        <v-card-text>
          <Bar :options="chartOptions" :data="chartData" width="auto" />
        </v-card-text>
        <v-card-actions>
          <v-btn color="blue darken-1" @click="showDialog = false">Close</v-btn>
          <!-- Button to change chart data to daily view -->
          <v-btn @click="changeChartData('date')">Daily</v-btn>
          <!-- Button to change chart data to monthly view -->
          <v-btn @click="changeChartData('month')">Month</v-btn>
          <!-- Button to change chart data to yearly view -->
          <v-btn @click="changeChartData('year')">Year</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<style scoped>
.chart-card {
  width: auto;
  height: auto;
}
</style>
